\section{Discussion}
\label{sec:discussion}

This section will discuss the general picture that rises from the current results and point out remarkable results and try to interpret them. We give a reflection of the process on this thesis. We will also give ideas that we think could be beneficial in future research or ideas that can be used to improve the current methodology.


\subsection{Discussion on image segmentation methodology and results}
Originally, we planned to use transfer learning on a Detectron2 or PyTorch pre-trained semantic segmentation model. This means we would take such a model and replace only the last layer with an untrained one, to then train that layer on new data that is more suitable for railway scenarios. The original plan was to train a network on RailSem19 data. Unfortunately, we repeatedly ran into problems while trying to get this transfer learning step to produce any meaningful results. One of the reasons for this was the lack of professional grade hardware that is necessary to train these large networks, but we also did not have enough experience or expertise in using these kinds of neural network libraries. It is important to point out that the Detectron2 framework is still under heavy development, so better support for transfer learning might be added in the future.

The results we did manage to get must therefore be taken into the context of not being the results of a segmentation model exclusively trained on railway related scenes. Considering that, the model actually manages to semantically segment the images fairly well, especially on short range. The effectiveness of the model is most noticeable when looking at the results of inference on the RailSem19 dataset, since we can actually compare the ground truth of the RailSem19 dataset qualitatively to these results. We can not do this quantitatively, because the labels of the different data sources do not match. We noticed the following things when looking through the inferred results. 

First, vegetation and sky is generally segmented correctly. This probably has to do with the fact that nearly every picture taken outside has both vegetation and sky in it, and thus a large number of training images probably had these classes in it. Second, the railways are also recognized most of the time, with some exceptions being when the tracks are covered in snow, when the picture is taken inside of a tunnel or when the picture is taken at night time. For a model that has only two railways specific labels, we found this to be an encouraging result. It gives the confidence to state that were a more specialized segmentation model used, the results would have been significantly better.

The panoptic segmentation model also had some clear drawbacks. As mentioned briefly in the results section, the quality of the segmentation seems to drop drastically as the distance of objects to the camera viewpoint increases. When looking at all images, this is most noticeable when looking at the railway label. Usually this distance proportional mislabelling means all objects slightly above and around the track are labelled as railroad instead, which is also reflected in Table \ref{tab:accuracy_ground_truth}. Another issue with the segmentation model is that a more general issue with any kind of object detection or recognition model: it can not recognize that which it does not have any knowledge of. This is most apparent in Figure \ref{fig:results_inference_electrical_box}, where it fails to figure out what an electricity box with paintings all over it is.


\subsection{Discussion on point cloud labelling results}
Because of the nature of our chosen approaches, the strengths and weaknesses of the segmentation model will propagate to the labelling of the point clouds, most notably in the results created with just the point projection labelling. The LDLS algorithm skews the labelling so much, that these pros and cons are not directly visible any more.

In general, the projection labelling method performs well enough that most big objects at ground level appear to be segmented correctly from a visual standpoint. This is also seen when examining the quantitative results for the platform label, where the experiment with projection based labelling with a viewing distance of 11 meters has an accuracy of 84\%, which is slightly higher than the minimum desired accuracy set by Fugro. Also from Table \ref{tab:accuracy_ground_truth}, it is evident that it is highly important to trim points based on their distance from the camera viewpoint. 61\% of platform points are misclassified as railroad points when using a high clipping radius with the projection labelling, which has everything to do with the degradation of segmentation quality for points that are far away from the camera. LDLS performs too poorly for both clipping radii we tested by the standards set by Fugro. Both the short and long range experiment give an empty label percentage of around 10\%, which is very disappointing. From the side view in Figures \ref{fig:results_station_view} and \ref{fig:results_start_view}, we can see that mainly the ground points are labelled as empty by LDLS, which means that if we had picked the rail track points as our basis for quantitative analysis, LDLS would probably have performed much worse. 

The point clouds that are created with LDLS look disappointing. Looking from above and from the side, a large number of points does not seem to be labelled. This makes it impossible to give a fair comparison between the projection labelling and LDLS labelling. We first thought this might be the result of too few iterations of the LDLS algorithm, but letting it run until convergence did not make any discerning difference in execution time or visual result, so these results are in fact achieved by the algorithm running until convergence already. The empty labels notwithstanding, visually the resulting point clouds look significantly worse than the projection ones, which was a very surprising result. We assumed at the start of this research that the LDLS methodology might improve the quality of the segmentation, but in fact it the segmentation became worse. What is also very interesting is that visually the LDLS with short range seems to be performing worse than with long range, which is in juxtaposition with the projection method. When looking in Figure \ref{fig:results_start_view}, a lot of railway and vegetation is labelled as gravel, which we have no explanation for. It appears that the LDLS algorithm pushes out correct labels and replaces them with bad labels.

A drawback that is unique for the projection method (and not testable for LDLS), is the obstruction of view of objects behind other objects. As mentioned in the introduction, because of the used LiDAR system that emits laser beams in a direction perpendicular to the camera view, objects obstructed from view by the cameras will still be detected by the LiDAR system. In this research, we have not taken this into account with any countermeasure. Since the platform is never obstructed from view, this is not reflected in the limited quantitative analysis. We could not find any completely obstructed objects in the point clouds that are completely visible in the video footage, in order to visually check and see what our methods would result in.


\subsection{Research recommendations}
For future research, we recommend to have access to reliable and relevant ground truth, both for training a segmentation model and verifying the quality of a chosen methodology. Having no access to (relevant and usable) ground truth in this research caused that we could only make some educated guesses as to whether our approaches worked. In related work, numerous statistical analyses are commonly performed to give a solid understanding of the actual outcome of these segmentation algorithms. As such, the scientific value of this work is limited, since proof by picture is no proof at all. We hope this work can still inspire others to delve deeper into this topic and come up with new ways to improve segmentation techniques, since semantic point cloud segmentation is very much still an open research question.

Apart from that, if people are still interested in using LDLS, we would advise to try and vary other parameters of the algorithm, such as the diffusion parameter and the size of the box of pixels that is connected to each projected point cloud point. Another reason LDLS fails is the number of labels that we tried to segment all at once; it might be that LDLS is better suited for segmentation of one or two labels at a time, like the authors do. Because of time constraints, we were not able to perform analyses for these topics.

An issue that has been purposely overlooked so far, is the issue of multiple labels per point. Because these methods uses the video data as central starting point and point cloud points are selected based on their position relative to the camera position, many points are classified multiple times. For this thesis and these evaluation methods, this was not problematic, since we only look at how many points are classified correctly. Points that are classified multiple times are counted separately for every time they are classified. However, in the case of using one of these methods to create point clouds that are then used as a basis to make an end product, all points must have a single label. The label confidence in LDLS did not work, so even for that method some heuristic must be added to determine what labels to pick, especially if multiple labels have equal occurrences on a certain point.

